--
--     o  0                          
--     | /       Copyright (c) 2013
--    (CL)---o   Critical Link, LLC  
--      \                            
--       O                           
--

library ieee;
use ieee.std_logic_1164.all;
use IEEE.NUMERIC_STD.ALL;

--! brief
--!	Top level for project to produce test pattern images on Microtronix
--!	Datacom Ltd. Camera Link Transmitter HSMC Daughter Card.
entity mityarm_5csx_dev_board_top is
	port 
	(
		-- HPS DDR
		HPS_DDR_A : out std_logic_vector(14 downto 0);
		HPS_DDR_BAS : out std_logic_vector(2 downto 0);
		HPS_DDR_CK_P : out std_logic;
		HPS_DDR_CK_N : out std_logic;
		HPS_DDR_CKE : out std_logic;
		HPS_DDR_CS0_N : out std_logic;
		HPS_DDR_RAS_N : out std_logic;
		HPS_DDR_CAS_N : out std_logic;
		HPS_DDR_WE_N : out std_logic;
		HPS_DDR_RESET_N : out std_logic;
		HPS_DDR_D : inout std_logic_vector(39 downto 0);
		HPS_DDR_DQS_P : inout std_logic_vector(4 downto 0);
		HPS_DDR_DQS_N : inout std_logic_vector(4 downto 0);
		HPS_DDR_DQM : out std_logic_vector(4 downto 0);
		HPS_RZQ0 : in std_logic;
		HPS_ODT : out std_logic;
		-- RGMII1
		RGMII1_TX_CLK : out std_logic;
		RGMII1_TXD0 : out std_logic;
		RGMII1_TXD1 : out std_logic;
		RGMII1_TXD2 : out std_logic;
		RGMII1_TXD3 : out std_logic;
		RGMII1_RXD0 : in std_logic;
		RGMII1_MDIO : inout std_logic;
		RGMII1_MDC : out std_logic;
		RGMII1_RX_CTL : in std_logic;
		RGMII1_TX_CTL : out std_logic;
		RGMII1_RX_CLK : in std_logic;
		RGMII1_RXD1 : in std_logic;
		RGMII1_RXD2 : in std_logic;
		RGMII1_RXD3 : in std_logic;
		RGMII1_RESETn : inout std_logic;
		-- QSPI
		QSPI_DQ0 : inout std_logic;
		QSPI_DQ1 : inout std_logic;
		QSPI_DQ2 : inout std_logic;
		QSPI_DQ3 : inout std_logic;
		QSPI_SS0 : out std_logic;
		QSPI_SS1 : out std_logic;
		QSPI_CLK : out std_logic;
		-- SDMMC
		SDMMC_CMD : inout std_logic;
		SDMMC_D0 : inout std_logic;
		SDMMC_D1 : inout std_logic;
		SDMMC_CLK : out std_logic;
		SDMMC_D2 : inout std_logic;
		SDMMC_D3 : inout std_logic;
		-- USB1
		USB1_ULPI_D0 : inout std_logic;
		USB1_ULPI_D1 : inout std_logic;
		USB1_ULPI_D2 : inout std_logic;
		USB1_ULPI_D3 : inout std_logic;
		USB1_ULPI_D4 : inout std_logic;
		USB1_ULPI_D5 : inout std_logic;
		USB1_ULPI_D6 : inout std_logic;
		USB1_ULPI_D7 : inout std_logic;
		USB1_ULPI_CLK : in std_logic;
		USB1_ULPI_STP : out std_logic;
		USB1_ULPI_DIR : in std_logic;
		USB1_ULPI_NXT : in std_logic;
		USB1_ULPI_CS : inout std_logic;
		USB1_ULPI_RESET_N : inout std_logic;
		-- UART0
		B7A_UART0_RX : in std_logic;
		B7A_UART0_TX : out std_logic;
		-- I2C0
		B7A_I2C0_SDA : inout std_logic;
		B7A_I2C0_SCL : inout std_logic;
		-- CAN0
		B7A_CAN0_RX : in std_logic;
		B7A_CAN0_TX : out std_logic;
		-- CAN1
		B7A_CAN1_RX : in std_logic;
		B7A_CAN1_TX : out std_logic;
		-- I2C1
		I2C1_SCL : inout std_logic;
		I2C1_SDA : inout std_logic;
		-- LEDs
		LED1 : inout std_logic;
		LED2 : inout std_logic;
		LED3 : inout std_logic;
		-- Switches
		SW1 : inout std_logic;
		SW2 : inout std_logic;
		SW3 : inout std_logic;

		-- HSMC1
		HSMC1_SMSDA : in std_logic;
		HSMC1_SMSCL : out std_logic;

		HSMC1_CLKOUT0 : out std_logic;
		HSMC1_CLKOUT1 : out std_logic;
		HSMC1_CLKOUT2 : out std_logic;
		HSMC1_CLKIN0 : in std_logic;
		HSMC1_CLKIN1 : in std_logic;
		HSMC1_CLKIN2 : in std_logic;

		HSMC1_PRSNTn : in std_logic;

		HSMC1_D0 : out std_logic;
		HSMC1_D1 : in std_logic;
		HSMC1_D2 : out std_logic;
		HSMC1_D3 : in std_logic;

		HSMC1_TX0 : out std_logic;
		HSMC1_TX1 : out std_logic;
		HSMC1_TX2 : out std_logic;
		HSMC1_TX3 : out std_logic;
		HSMC1_TX4 : out std_logic;
		HSMC1_TX5 : out std_logic;
		HSMC1_TX6 : out std_logic;
		HSMC1_TX7 : out std_logic;
		HSMC1_TX8 : out std_logic;
		HSMC1_TX9 : out std_logic;
		HSMC1_TX10 : out std_logic;
		HSMC1_TX11 : out std_logic;
		HSMC1_TX12 : out std_logic;
		HSMC1_TX13 : out std_logic;
		HSMC1_TX14 : out std_logic;
		HSMC1_TX15 : out std_logic;
		HSMC1_TX16 : out std_logic;

		HSMC1_RX0 : in std_logic;
		HSMC1_RX1 : in std_logic;
		HSMC1_RX2 : in std_logic;
		HSMC1_RX3 : in std_logic;
		HSMC1_RX4 : in std_logic;
		HSMC1_RX5 : in std_logic;
		HSMC1_RX6 : in std_logic;
		HSMC1_RX7 : in std_logic;
		HSMC1_RX8 : in std_logic;
		HSMC1_RX9 : in std_logic;
		HSMC1_RX10 : in std_logic;
		HSMC1_RX11 : in std_logic;
		HSMC1_RX12 : in std_logic;
		HSMC1_RX13 : in std_logic;
		HSMC1_RX14 : in std_logic;
		HSMC1_RX15 : in std_logic;
		HSMC1_RX16 : in std_logic;

		CLK2DDR : in std_logic --! 100 MHz clock typically used to drive DDR. 
	);
end entity mityarm_5csx_dev_board_top;

--------------------------------------------------------------------------
-- ARCHITECTURE
--------------------------------------------------------------------------
architecture rtl of mityarm_5csx_dev_board_top is

	--------------------------------------------------------------------------
        -- Constant Declarations
        --------------------------------------------------------------------------
	constant IMG_WIDTH : unsigned(11 downto 0) := TO_UNSIGNED(2560, 12);
	constant IMG_HEIGHT : unsigned(11 downto 0) := TO_UNSIGNED(2160, 12);
	constant NULL_LENGTH : unsigned(11 downto 0) := TO_UNSIGNED(256, 12); --! Number of cycles between rows/frames.

	constant DEBUG_KEEP : string := "true"; 

	--------------------------------------------------------------------------
	-- Signal Declarations
	--------------------------------------------------------------------------
	attribute keep : string;

	type t_img_state is 
		(
			INTER_FRAME_STATE,
			ROW_VALID_STATE,
			ROW_NULL_STATE
		);
	signal s_img_state : t_img_state := INTER_FRAME_STATE;

	signal s_tx_enable : std_logic := '0';
	signal s_tx_85x7 : std_logic := '0';
	signal s_85mhz : std_logic := '0';
	attribute keep of s_85mhz : signal is DEBUG_KEEP;
	signal s_tx_enable_b : std_logic := '0';
	signal s_tx_85x7_b : std_logic := '0';
	signal s_85mhz_b : std_logic := '0';

	signal s_pll_rst : std_logic := '0';
	signal s_gen_rst : std_logic := '0';

	signal s_hps_0_h2f_user1_clock_clk : std_logic := '0';

	signal s_row_cnt : unsigned(11 downto 0) := (others => '0');
	signal s_col_cnt : unsigned(11 downto 0) := (others => '0');
	signal s_null_cnt : unsigned(11 downto 0) := (others => '0');

	signal s_walking_one : std_logic_vector(27 downto 0) := (others => '0');

	signal s_camlink_frame_v : std_logic := '0';
	signal s_camlink_line_v : std_logic := '0';
	signal s_camlink_port_a : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_b : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_c : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_d : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_e : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_f : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_g : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_h : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_i : std_logic_vector(7 downto 0) := (others => '0');
	signal s_camlink_port_j : std_logic_vector(7 downto 0) := (others => '0');

	signal s_CAMLINK_STRB_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_STRB_parallel_shifted : std_logic_vector(6 downto 0) := (others => '0');
	
	signal s_CAMLINK_X0_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_X1_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_X2_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_X3_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Y0_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Y1_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Y2_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Y3_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Z0_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Z1_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Z2_parallel : std_logic_vector(6 downto 0) := (others => '0');
	signal s_CAMLINK_Z3_parallel : std_logic_vector(6 downto 0) := (others => '0');

	signal s_shift_sel : std_logic_vector(2 downto 0) := (others => '0');

	signal s_C1_X0_P : std_logic := '0';
	signal s_C1_X1_P : std_logic := '0';
	signal s_C1_X2_P : std_logic := '0';
	signal s_C1_X3_P : std_logic := '0';
	signal s_C1_XCLK_P : std_logic := '0';

	signal s_C2_Y0_P : std_logic := '0';
	signal s_C2_Y1_P : std_logic := '0';
	signal s_C2_Y2_P : std_logic := '0';
	signal s_C2_Y3_P : std_logic := '0';
	signal s_C2_YCLK_P : std_logic := '0';

	signal s_C2_Z0_P : std_logic := '0';
	signal s_C2_Z1_P : std_logic := '0';
	signal s_C2_Z2_P : std_logic := '0';
	signal s_C2_Z3_P : std_logic := '0';
	signal s_C2_ZCLK_P : std_logic := '0';

	signal s_HSMC1_RX8 : std_logic := '0'; --! Dummy register to make sure pin and 100 ohm termination is not stripped out.
	attribute keep of s_HSMC1_RX8 : signal is "true";

	--------------------------------------------------------------------------
	-- Component Declarations
	--------------------------------------------------------------------------
	component mityarm_5csx_dev_board is
		port (
			hps_ddr_mem_a                    : out   std_logic_vector(14 downto 0);                    -- mem_a
			hps_ddr_mem_ba                   : out   std_logic_vector(2 downto 0);                     -- mem_ba
			hps_ddr_mem_ck                   : out   std_logic;                                        -- mem_ck
			hps_ddr_mem_ck_n                 : out   std_logic;                                        -- mem_ck_n
			hps_ddr_mem_cke                  : out   std_logic;                                        -- mem_cke
			hps_ddr_mem_cs_n                 : out   std_logic;                                        -- mem_cs_n
			hps_ddr_mem_ras_n                : out   std_logic;                                        -- mem_ras_n
			hps_ddr_mem_cas_n                : out   std_logic;                                        -- mem_cas_n
			hps_ddr_mem_we_n                 : out   std_logic;                                        -- mem_we_n
			hps_ddr_mem_reset_n              : out   std_logic;                                        -- mem_reset_n
			hps_ddr_mem_dq                   : inout std_logic_vector(39 downto 0) := (others => 'X'); -- mem_dq
			hps_ddr_mem_dqs                  : inout std_logic_vector(4 downto 0)  := (others => 'X'); -- mem_dqs
			hps_ddr_mem_dqs_n                : inout std_logic_vector(4 downto 0)  := (others => 'X'); -- mem_dqs_n
			hps_ddr_mem_odt                  : out   std_logic;                                        -- mem_odt
			hps_ddr_mem_dm                   : out   std_logic_vector(4 downto 0);                     -- mem_dm
			hps_ddr_oct_rzqin                : in    std_logic                     := 'X';             -- oct_rzqin
			hps_io_hps_io_emac1_inst_TX_CLK : out   std_logic;                                        -- hps_io_emac1_inst_TX_CLK
			hps_io_hps_io_emac1_inst_TXD0   : out   std_logic;                                        -- hps_io_emac1_inst_TXD0
			hps_io_hps_io_emac1_inst_TXD1   : out   std_logic;                                        -- hps_io_emac1_inst_TXD1
			hps_io_hps_io_emac1_inst_TXD2   : out   std_logic;                                        -- hps_io_emac1_inst_TXD2
			hps_io_hps_io_emac1_inst_TXD3   : out   std_logic;                                        -- hps_io_emac1_inst_TXD3
			hps_io_hps_io_emac1_inst_RXD0   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD0
			hps_io_hps_io_emac1_inst_MDIO   : inout std_logic                     := 'X';             -- hps_io_emac1_inst_MDIO
			hps_io_hps_io_emac1_inst_MDC    : out   std_logic;                                        -- hps_io_emac1_inst_MDC
			hps_io_hps_io_emac1_inst_RX_CTL : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RX_CTL
			hps_io_hps_io_emac1_inst_TX_CTL : out   std_logic;                                        -- hps_io_emac1_inst_TX_CTL
			hps_io_hps_io_emac1_inst_RX_CLK : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RX_CLK
			hps_io_hps_io_emac1_inst_RXD1   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD1
			hps_io_hps_io_emac1_inst_RXD2   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD2
			hps_io_hps_io_emac1_inst_RXD3   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD3
			hps_io_hps_io_qspi_inst_SS1     : out   std_logic;                                        -- hps_io_qspi_inst_SS1
			hps_io_hps_io_qspi_inst_IO0     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO0
			hps_io_hps_io_qspi_inst_IO1     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO1
			hps_io_hps_io_qspi_inst_IO2     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO2
			hps_io_hps_io_qspi_inst_IO3     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO3
			hps_io_hps_io_qspi_inst_SS0     : out   std_logic;                                        -- hps_io_qspi_inst_SS0
			hps_io_hps_io_qspi_inst_CLK     : out   std_logic;                                        -- hps_io_qspi_inst_CLK
			hps_io_hps_io_sdio_inst_CMD     : inout std_logic                     := 'X';             -- hps_io_sdio_inst_CMD
			hps_io_hps_io_sdio_inst_D0      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D0
			hps_io_hps_io_sdio_inst_D1      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D1
			hps_io_hps_io_sdio_inst_CLK     : out   std_logic;                                        -- hps_io_sdio_inst_CLK
			hps_io_hps_io_sdio_inst_D2      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D2
			hps_io_hps_io_sdio_inst_D3      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D3
			hps_io_hps_io_usb1_inst_D0      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D0
			hps_io_hps_io_usb1_inst_D1      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D1
			hps_io_hps_io_usb1_inst_D2      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D2
			hps_io_hps_io_usb1_inst_D3      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D3
			hps_io_hps_io_usb1_inst_D4      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D4
			hps_io_hps_io_usb1_inst_D5      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D5
			hps_io_hps_io_usb1_inst_D6      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D6
			hps_io_hps_io_usb1_inst_D7      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D7
			hps_io_hps_io_usb1_inst_CLK     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_CLK
			hps_io_hps_io_usb1_inst_STP     : out   std_logic;                                        -- hps_io_usb1_inst_STP
			hps_io_hps_io_usb1_inst_DIR     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_DIR
			hps_io_hps_io_usb1_inst_NXT     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_NXT
			hps_io_hps_io_uart0_inst_RX     : in    std_logic                     := 'X';             -- hps_io_uart0_inst_RX
			hps_io_hps_io_uart0_inst_TX     : out   std_logic;                                        -- hps_io_uart0_inst_TX
			hps_io_hps_io_i2c0_inst_SDA     : inout std_logic                     := 'X';             -- hps_io_i2c0_inst_SDA
			hps_io_hps_io_i2c0_inst_SCL     : inout std_logic                     := 'X';             -- hps_io_i2c0_inst_SCL
			hps_io_hps_io_i2c1_inst_SDA     : inout std_logic                     := 'X';             -- hps_io_i2c1_inst_SDA
			hps_io_hps_io_i2c1_inst_SCL     : inout std_logic                     := 'X';             -- hps_io_i2c1_inst_SCL
			hps_io_hps_io_can0_inst_RX      : in    std_logic                     := 'X';             -- hps_io_can0_inst_RX
			hps_io_hps_io_can0_inst_TX      : out   std_logic;                                        -- hps_io_can0_inst_TX
			hps_io_hps_io_can1_inst_RX      : in    std_logic                     := 'X';             -- hps_io_can1_inst_RX
			hps_io_hps_io_can1_inst_TX      : out   std_logic;                                        -- hps_io_can1_inst_TX
			hps_io_hps_io_gpio_inst_GPIO00  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO00
			hps_io_hps_io_gpio_inst_GPIO09  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO09
			hps_io_hps_io_gpio_inst_GPIO28  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO28
			hps_io_hps_io_gpio_inst_GPIO37  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO37
			hps_io_hps_io_gpio_inst_GPIO40  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO40
			hps_io_hps_io_gpio_inst_GPIO41  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO41
			hps_io_hps_io_gpio_inst_GPIO48  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO48
			hps_io_hps_io_gpio_inst_GPIO49  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO49
			hps_io_hps_io_gpio_inst_GPIO50  : inout std_logic                     := 'X';             -- hps_io_gpio_inst_GPIO50
			hps_0_h2f_user1_clock_clk       : out   std_logic                                         -- clk
		);
	end component mityarm_5csx_dev_board;

	component pll_x7
		port (
			refclk   : in  std_logic := '0'; --  refclk.clk
			rst      : in  std_logic := '0'; --   reset.reset
			outclk_0 : out std_logic;        -- outclk0.clk
			outclk_1 : out std_logic;        -- outclk1.clk
			outclk_2 : out std_logic;
			locked   : out std_logic         --  locked.export
		);
	end component;	

	component pll_x7_phase_adjust is
		port (
			refclk   : in  std_logic := '0'; --  refclk.clk
			rst      : in  std_logic := '0'; --   reset.reset
			outclk_0 : out std_logic;        -- outclk0.clk
			outclk_1 : out std_logic;        -- outclk1.clk
			outclk_2 : out std_logic;        -- outclk2.clk
			locked   : out std_logic         --  locked.export
		);
	end component pll_x7_phase_adjust;
	
	component tx_5lane IS
		PORT
		(
			tx_enable		: IN STD_LOGIC ;
			tx_in		: IN STD_LOGIC_VECTOR (34 DOWNTO 0);
			tx_inclock		: IN STD_LOGIC ;
			tx_out		: OUT STD_LOGIC_VECTOR (4 DOWNTO 0)
		);
	END component;

	component issp IS
		PORT
		(
			probe		: IN STD_LOGIC_VECTOR (4 DOWNTO 0);
			source		: OUT STD_LOGIC_VECTOR (4 DOWNTO 0)
		);
	END component issp;

begin  

	----------------------------------------------------------------------------
	-- Component instantiations
	----------------------------------------------------------------------------
	--! Qsys stuff (contains HPS and such).
	u0 : component mityarm_5csx_dev_board
		port map (
			hps_ddr_mem_a                   => HPS_DDR_A,                   -- hps_ddr.mem_a
			hps_ddr_mem_ba                  => HPS_DDR_BAS,                  --       .mem_ba
			hps_ddr_mem_ck                  => HPS_DDR_CK_P,                  --       .mem_ck
			hps_ddr_mem_ck_n                => HPS_DDR_CK_N,                --       .mem_ck_n
			hps_ddr_mem_cke                 => HPS_DDR_CKE,                 --       .mem_cke
			hps_ddr_mem_cs_n                => HPS_DDR_CS0_N,                --       .mem_cs_n
			hps_ddr_mem_ras_n               => HPS_DDR_RAS_N,               --       .mem_ras_n
			hps_ddr_mem_cas_n               => HPS_DDR_CAS_N,               --       .mem_cas_n
			hps_ddr_mem_we_n                => HPS_DDR_WE_N,                --       .mem_we_n
			hps_ddr_mem_reset_n             => HPS_DDR_RESET_N,             --       .mem_reset_n
			hps_ddr_mem_dq                  => HPS_DDR_D,                  --       .mem_dq
			hps_ddr_mem_dqs                 => HPS_DDR_DQS_P,                 --       .mem_dqs
			hps_ddr_mem_dqs_n               => HPS_DDR_DQS_N,               --       .mem_dqs_n
			hps_ddr_mem_odt                 => HPS_ODT,                 --       .mem_odt
			hps_ddr_mem_dm                  => HPS_DDR_DQM,                  --       .mem_dm
			hps_ddr_oct_rzqin               => HPS_RZQ0,               --       .oct_rzqin
			hps_io_hps_io_emac1_inst_TX_CLK => RGMII1_TX_CLK, -- hps_io.hps_io_emac1_inst_TX_CLK
			hps_io_hps_io_emac1_inst_TXD0   => RGMII1_TXD0,   --       .hps_io_emac1_inst_TXD0
			hps_io_hps_io_emac1_inst_TXD1   => RGMII1_TXD1,   --       .hps_io_emac1_inst_TXD1
			hps_io_hps_io_emac1_inst_TXD2   => RGMII1_TXD2,   --       .hps_io_emac1_inst_TXD2
			hps_io_hps_io_emac1_inst_TXD3   => RGMII1_TXD3,   --       .hps_io_emac1_inst_TXD3
			hps_io_hps_io_emac1_inst_RXD0   => RGMII1_RXD0,   --       .hps_io_emac1_inst_RXD0
			hps_io_hps_io_emac1_inst_RXD1   => RGMII1_RXD1,   --       .hps_io_emac1_inst_RXD1
			hps_io_hps_io_emac1_inst_RXD2   => RGMII1_RXD2,   --       .hps_io_emac1_inst_RXD2
			hps_io_hps_io_emac1_inst_RXD3   => RGMII1_RXD3,   --       .hps_io_emac1_inst_RXD3
			hps_io_hps_io_emac1_inst_MDIO   => RGMII1_MDIO,   --       .hps_io_emac1_inst_MDIO
			hps_io_hps_io_emac1_inst_MDC    => RGMII1_MDC,    --       .hps_io_emac1_inst_MDC
			hps_io_hps_io_emac1_inst_RX_CTL => RGMII1_RX_CTL, --       .hps_io_emac1_inst_RX_CTL
			hps_io_hps_io_emac1_inst_TX_CTL => RGMII1_TX_CTL, --       .hps_io_emac1_inst_TX_CTL
			hps_io_hps_io_emac1_inst_RX_CLK => RGMII1_RX_CLK, --       .hps_io_emac1_inst_RX_CLK
			hps_io_hps_io_qspi_inst_SS1    => QSPI_SS1,    -- hps_io.hps_io_qspi_inst_SS1
			hps_io_hps_io_qspi_inst_IO0    => QSPI_DQ0,    --       .hps_io_qspi_inst_IO0
			hps_io_hps_io_qspi_inst_IO1    => QSPI_DQ1,    --       .hps_io_qspi_inst_IO1
			hps_io_hps_io_qspi_inst_IO2    => QSPI_DQ2,    --       .hps_io_qspi_inst_IO2
			hps_io_hps_io_qspi_inst_IO3    => QSPI_DQ3,    --       .hps_io_qspi_inst_IO3
			hps_io_hps_io_qspi_inst_SS0    => QSPI_SS0,    --       .hps_io_qspi_inst_SS0
			hps_io_hps_io_qspi_inst_CLK    => QSPI_CLK,    --       .hps_io_qspi_inst_CLK
			hps_io_hps_io_sdio_inst_CMD     => SDMMC_CMD,     --       .hps_io_sdio_inst_CMD
			hps_io_hps_io_sdio_inst_D0      => SDMMC_D0,      --       .hps_io_sdio_inst_D0
			hps_io_hps_io_sdio_inst_D1      => SDMMC_D1,      --       .hps_io_sdio_inst_D1
			hps_io_hps_io_sdio_inst_D2      => SDMMC_D2,      --       .hps_io_sdio_inst_D2
			hps_io_hps_io_sdio_inst_D3      => SDMMC_D3,      --       .hps_io_sdio_inst_D3
			hps_io_hps_io_sdio_inst_CLK     => SDMMC_CLK,     --       .hps_io_sdio_inst_CLK
			hps_io_hps_io_usb1_inst_D0     => USB1_ULPI_D0,     --       .hps_io_usb1_inst_D0
			hps_io_hps_io_usb1_inst_D1     => USB1_ULPI_D1,     --       .hps_io_usb1_inst_D1
			hps_io_hps_io_usb1_inst_D2     => USB1_ULPI_D2,     --       .hps_io_usb1_inst_D2
			hps_io_hps_io_usb1_inst_D3     => USB1_ULPI_D3,     --       .hps_io_usb1_inst_D3
			hps_io_hps_io_usb1_inst_D4     => USB1_ULPI_D4,     --       .hps_io_usb1_inst_D4
			hps_io_hps_io_usb1_inst_D5     => USB1_ULPI_D5,     --       .hps_io_usb1_inst_D5
			hps_io_hps_io_usb1_inst_D6     => USB1_ULPI_D6,     --       .hps_io_usb1_inst_D6
			hps_io_hps_io_usb1_inst_D7     => USB1_ULPI_D7,     --       .hps_io_usb1_inst_D7
			hps_io_hps_io_usb1_inst_CLK    => USB1_ULPI_CLK,    --       .hps_io_usb1_inst_CLK
			hps_io_hps_io_usb1_inst_STP    => USB1_ULPI_STP,    --       .hps_io_usb1_inst_STP
			hps_io_hps_io_usb1_inst_DIR    => USB1_ULPI_DIR,    --       .hps_io_usb1_inst_DIR
			hps_io_hps_io_usb1_inst_NXT    => USB1_ULPI_NXT,    --       .hps_io_usb1_inst_NXT
			hps_io_hps_io_uart0_inst_RX    => B7A_UART0_RX,    --       .hps_io_uart0_inst_RX
			hps_io_hps_io_uart0_inst_TX    => B7A_UART0_TX,    --       .hps_io_uart0_inst_TX
			hps_io_hps_io_i2c0_inst_SDA    => B7A_I2C0_SDA,    --       .hps_io_i2c0_inst_SDA
			hps_io_hps_io_i2c0_inst_SCL    => B7A_I2C0_SCL,    --       .hps_io_i2c0_inst_SCL
			hps_io_hps_io_i2c1_inst_SDA    => I2C1_SDA,          -- hps_io_i2c1_inst_SDA
			hps_io_hps_io_i2c1_inst_SCL    => I2C1_SCL,          -- hps_io_i2c1_inst_SCL
			hps_io_hps_io_can0_inst_RX      => B7A_CAN0_RX,      --       .hps_io_can0_inst_RX
			hps_io_hps_io_can0_inst_TX      => B7a_CAN0_TX,      --       .hps_io_can0_inst_TX
			hps_io_hps_io_can1_inst_RX      => B7A_CAN1_RX,      --       .hps_io_can1_inst_RX
			hps_io_hps_io_can1_inst_TX      => B7A_CAN1_TX,      --       .hps_io_can1_inst_TX
			hps_io_hps_io_gpio_inst_GPIO00 => USB1_ULPI_CS, --       .hps_io_gpio_inst_GPIO00
			hps_io_hps_io_gpio_inst_GPIO09 => USB1_ULPI_RESET_N,  --       .hps_io_gpio_inst_GPIO09
			hps_io_hps_io_gpio_inst_GPIO48  => RGMII1_RESETn,   --       .hps_io_gpio_inst_GPIO48
			hps_io_hps_io_gpio_inst_GPIO28  => LED3,           -- hps_io_gpio_inst_GPIO28
			hps_io_hps_io_gpio_inst_GPIO37  => SW1,            -- hps_io_gpio_inst_GPIO37
			hps_io_hps_io_gpio_inst_GPIO40  => SW2,            -- hps_io_gpio_inst_GPIO40
			hps_io_hps_io_gpio_inst_GPIO41  => SW3,             -- hps_io_gpio_inst_GPIO41
			hps_io_hps_io_gpio_inst_GPIO49  => LED2,            -- hps_io_gpio_inst_GPIO49
			hps_io_hps_io_gpio_inst_GPIO50  => LED1,            -- hps_io_gpio_inst_GPIO50
			hps_0_h2f_user1_clock_clk => s_hps_0_h2f_user1_clock_clk
		);

	--! In-System Source and Probe component. Perfect for toggling some debug stuff if needed.
	ISSP_INST : issp
		PORT map
		(
			probe => "00000", 
			source(0) => s_pll_rst,
			source(1) => s_gen_rst,
			source(4 downto 2) => s_shift_sel
		);

	--! Process to generate test pattern image.
	TEST_PATTERN_PROC : process (s_85mhz)
	begin
		if rising_edge(s_85mhz) then
			-- Frame and line are not valid by default
			s_camlink_frame_v <= '0';
			s_camlink_line_v <= '0';

			if (s_gen_rst = '1') then
				s_img_state <= INTER_FRAME_STATE;
				s_null_cnt <= (others => '0');
				s_walking_one <= (others => '0');
				s_camlink_port_a <= (others => '0');
				s_camlink_port_b <= (others => '0');
				s_camlink_port_c <= (others => '0');
				s_camlink_port_d <= (others => '0');
				s_camlink_port_e <= (others => '0');
				s_camlink_port_f <= (others => '0');
				s_camlink_port_g <= (others => '0');
				s_camlink_port_h <= (others => '0');
				s_camlink_port_i <= (others => '0');
				s_camlink_port_j <= (others => '0');
			else
				case s_img_state is
					when INTER_FRAME_STATE =>

						s_walking_one <= (others => '0');

						s_null_cnt <= s_null_cnt + 1;	

						s_col_cnt <= (others => '0');
						s_row_cnt <= (others => '0');

						s_camlink_port_a <= (others => '0');
						s_camlink_port_b <= (others => '0');
						s_camlink_port_c <= (others => '0');
						s_camlink_port_d <= (others => '0');
						s_camlink_port_e <= (others => '0');
						s_camlink_port_f <= (others => '0');
						s_camlink_port_g <= (others => '0');
						s_camlink_port_h <= (others => '0');
						s_camlink_port_i <= (others => '0');
						s_camlink_port_j <= (others => '0');

						s_walking_one <= (0 => '1', others => '0');

						if (s_null_cnt >= NULL_LENGTH) then
							s_null_cnt <= (others => '0');
							s_img_state <= ROW_VALID_STATE;
						end if;

					when ROW_VALID_STATE =>
						s_camlink_frame_v <= '1';
						s_camlink_line_v <= '1';
						s_col_cnt <= s_col_cnt + 1;

						s_walking_one <= s_walking_one(26 downto 0) & s_walking_one(27);

						-- If we are currently outputting the last pixel of the row, we need to change states.
						if (s_col_cnt >= (IMG_WIDTH/10)-1) then
							-- Reset column count
							s_col_cnt <= (others => '0');
							-- Increment that we have put out one more row.
							s_row_cnt <= s_row_cnt + 1;
							-- Move to null state between rows
							s_img_state <= ROW_NULL_STATE;
						end if;
			
					when ROW_NULL_STATE => 
						s_camlink_frame_v <= '1';
						s_camlink_line_v <= '0';

						s_walking_one <= (others => '0');

						s_null_cnt <= s_null_cnt + 1;	

						if (s_null_cnt >= NULL_LENGTH) then
							s_camlink_port_a <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0));
							s_camlink_port_b <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_c <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_d <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_e <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_f <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_g <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_h <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_i <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 
							s_camlink_port_j <= STD_LOGIC_VECTOR(s_row_cnt(7 downto 0)); 

							s_camlink_port_a(7) <= not(s_camlink_port_a(7));
							s_camlink_port_b(7) <= not(s_camlink_port_b(7));
							s_camlink_port_c(7) <= not(s_camlink_port_c(7));
							s_camlink_port_d(7) <= not(s_camlink_port_d(7));
							s_camlink_port_e(7) <= not(s_camlink_port_e(7));
							s_camlink_port_f(7) <= not(s_camlink_port_f(7));
							s_camlink_port_g(7) <= not(s_camlink_port_g(7));
							s_camlink_port_h(7) <= not(s_camlink_port_h(7));
							s_camlink_port_i(7) <= not(s_camlink_port_i(7));
							s_camlink_port_j(7) <= not(s_camlink_port_j(7));

							s_walking_one <= (0 => '1', others => '0');

							s_null_cnt <= (others => '0');
							if (s_row_cnt >= IMG_HEIGHT) then
								-- At end of frame reset row counter
								s_row_cnt <= (others => '0');
								s_img_state <= INTER_FRAME_STATE;
							else
								s_img_state <= ROW_VALID_STATE;
							end if;
						end if;
				end case;
			end if;
		end if;
	end process TEST_PATTERN_PROC;

	s_CAMLINK_STRB_parallel <= "1100011";
	-- This is really more of a debug thing than anything else:
	-- The camera link strobe for Chip Z is on the opposite side of the chip. Thus there will be a delay that sometimes
	-- we can account for simply by rotating the strobe pattern. 
	s_CAMLINK_STRB_parallel_shifted <= 
		"1110001" when s_shift_sel = "000" else
		"1000111" when s_shift_sel = "001" else
		"0001111" when s_shift_sel = "010" else
		"0011110" when s_shift_sel = "011" else
		"0111100" when s_shift_sel = "100" else
		"1111000" when s_shift_sel = "101" else
		"1100011";
	
	-- Chip X mapping (silly confusing Channel Link)
	s_CAMLINK_X0_parallel(0) <= s_camlink_port_a(0);
	s_CAMLINK_X0_parallel(1) <= s_camlink_port_a(1);
	s_CAMLINK_X0_parallel(2) <= s_camlink_port_a(2);
	s_CAMLINK_X0_parallel(3) <= s_camlink_port_a(3);
	s_CAMLINK_X0_parallel(4) <= s_camlink_port_a(4);
	s_CAMLINK_X0_parallel(5) <= s_camlink_port_a(6);
	s_CAMLINK_X0_parallel(6) <= s_camlink_port_a(7);

	s_CAMLINK_X1_parallel(0) <= s_camlink_port_b(0);
	s_CAMLINK_X1_parallel(1) <= s_camlink_port_b(1);
	s_CAMLINK_X1_parallel(2) <= s_camlink_port_b(4);
	s_CAMLINK_X1_parallel(3) <= s_camlink_port_b(5);
	s_CAMLINK_X1_parallel(4) <= s_camlink_port_b(6);
	s_CAMLINK_X1_parallel(5) <= s_camlink_port_b(7);
	s_CAMLINK_X1_parallel(6) <= s_camlink_port_c(2);

	s_CAMLINK_X2_parallel(0) <= s_camlink_port_c(3);
	s_CAMLINK_X2_parallel(1) <= s_camlink_port_c(4);
	s_CAMLINK_X2_parallel(2) <= s_camlink_port_c(5);
	s_CAMLINK_X2_parallel(3) <= s_camlink_port_c(6);
	s_CAMLINK_X2_parallel(4) <= s_camlink_line_v;
	s_CAMLINK_X2_parallel(5) <= s_camlink_frame_v;
	s_CAMLINK_X2_parallel(6) <= s_camlink_port_d(0);

	s_CAMLINK_X3_parallel(0) <= s_camlink_port_d(1);
	s_CAMLINK_X3_parallel(1) <= s_camlink_port_a(5);
	s_CAMLINK_X3_parallel(2) <= s_camlink_port_b(2);
	s_CAMLINK_X3_parallel(3) <= s_camlink_port_b(3);
	s_CAMLINK_X3_parallel(4) <= s_camlink_port_c(0);
	s_CAMLINK_X3_parallel(5) <= s_camlink_port_c(1);
	s_CAMLINK_X3_parallel(6) <= s_camlink_port_c(7);

	-- Chip Y mapping (silly confusing Channel Link)
	s_CAMLINK_Y0_parallel(0) <= s_camlink_port_d(2);
	s_CAMLINK_Y0_parallel(1) <= s_camlink_port_d(3);
	s_CAMLINK_Y0_parallel(2) <= s_camlink_port_d(4);
	s_CAMLINK_Y0_parallel(3) <= s_camlink_port_d(5);
	s_CAMLINK_Y0_parallel(4) <= s_camlink_port_d(6);
	s_CAMLINK_Y0_parallel(5) <= s_camlink_port_e(0);
	s_CAMLINK_Y0_parallel(6) <= s_camlink_port_e(1);

	s_CAMLINK_Y1_parallel(0) <= s_camlink_port_e(2);
	s_CAMLINK_Y1_parallel(1) <= s_camlink_port_e(3);
	s_CAMLINK_Y1_parallel(2) <= s_camlink_port_e(6);
	s_CAMLINK_Y1_parallel(3) <= s_camlink_port_e(7);
	s_CAMLINK_Y1_parallel(4) <= s_camlink_port_f(0);
	s_CAMLINK_Y1_parallel(5) <= s_camlink_port_f(1);
	s_CAMLINK_Y1_parallel(6) <= s_camlink_port_f(4);

	s_CAMLINK_Y2_parallel(0) <= s_camlink_port_f(5);
	s_CAMLINK_Y2_parallel(1) <= s_camlink_port_f(6);
	s_CAMLINK_Y2_parallel(2) <= s_camlink_port_f(7);
	s_CAMLINK_Y2_parallel(3) <= s_camlink_port_g(0);
	s_CAMLINK_Y2_parallel(4) <= s_camlink_port_g(2);
	s_CAMLINK_Y2_parallel(5) <= s_camlink_port_g(3);
	s_CAMLINK_Y2_parallel(6) <= s_camlink_port_g(4);

	s_CAMLINK_Y3_parallel(0) <= s_camlink_line_v;
	s_CAMLINK_Y3_parallel(1) <= s_camlink_port_d(7);
	s_CAMLINK_Y3_parallel(2) <= s_camlink_port_e(4);
	s_CAMLINK_Y3_parallel(3) <= s_camlink_port_e(5);
	s_CAMLINK_Y3_parallel(4) <= s_camlink_port_f(2);
	s_CAMLINK_Y3_parallel(5) <= s_camlink_port_f(3);
	s_CAMLINK_Y3_parallel(6) <= s_camlink_port_g(1);

	-- Chip Z mapping (silly confusing Channel Link)
	s_CAMLINK_Z0_parallel(0) <= s_camlink_port_g(5);
	s_CAMLINK_Z0_parallel(1) <= s_camlink_port_g(6);
	s_CAMLINK_Z0_parallel(2) <= s_camlink_port_g(7);
	s_CAMLINK_Z0_parallel(3) <= s_camlink_port_h(0);
	s_CAMLINK_Z0_parallel(4) <= s_camlink_port_h(1);
	s_CAMLINK_Z0_parallel(5) <= s_camlink_port_h(3);
	s_CAMLINK_Z0_parallel(6) <= s_camlink_port_h(4);

	s_CAMLINK_Z1_parallel(0) <= s_camlink_port_h(5);
	s_CAMLINK_Z1_parallel(1) <= s_camlink_port_h(6);
	s_CAMLINK_Z1_parallel(2) <= s_camlink_port_i(1);
	s_CAMLINK_Z1_parallel(3) <= s_camlink_port_i(2);
	s_CAMLINK_Z1_parallel(4) <= s_camlink_port_i(3);
	s_CAMLINK_Z1_parallel(5) <= s_camlink_port_i(4);
	s_CAMLINK_Z1_parallel(6) <= s_camlink_port_i(7);

	s_CAMLINK_Z2_parallel(0) <= s_camlink_port_j(0);
	s_CAMLINK_Z2_parallel(1) <= s_camlink_port_j(1);
	s_CAMLINK_Z2_parallel(2) <= s_camlink_port_j(2);
	s_CAMLINK_Z2_parallel(3) <= s_camlink_port_j(3);
	s_CAMLINK_Z2_parallel(4) <= s_camlink_port_j(5);
	s_CAMLINK_Z2_parallel(5) <= s_camlink_port_j(6);
	s_CAMLINK_Z2_parallel(6) <= s_camlink_port_j(7);

	s_CAMLINK_Z3_parallel(0) <= s_camlink_line_v;
	s_CAMLINK_Z3_parallel(1) <= s_camlink_port_h(2);
	s_CAMLINK_Z3_parallel(2) <= s_camlink_port_h(7);
	s_CAMLINK_Z3_parallel(3) <= s_camlink_port_i(0);
	s_CAMLINK_Z3_parallel(4) <= s_camlink_port_i(5);
	s_CAMLINK_Z3_parallel(5) <= s_camlink_port_i(6);
	s_CAMLINK_Z3_parallel(6) <= s_camlink_port_j(4);

	-- Need to produce pixel clock and serializer bit clock and enable (to mark which bit is first for the serializer).
	pll85 : pll_x7
		port map (
			refclk   => s_hps_0_h2f_user1_clock_clk,
			rst      => s_pll_rst,
			outclk_0 => s_tx_85x7,
			outclk_1 => s_tx_enable,
			outclk_2 => s_85mhz,
			locked   => open
		);
		
	tx_p1 : tx_5lane
		PORT MAP
		(
			tx_enable => s_tx_enable,
			tx_in(6 downto 0) => s_CAMLINK_STRB_parallel,
			tx_in(13 downto 7) => s_CAMLINK_X0_parallel,
			tx_in(20 downto 14) => s_CAMLINK_X1_parallel,
			tx_in(27 downto 21) => s_CAMLINK_X2_parallel,
			tx_in(34 downto 28) => s_CAMLINK_X3_parallel,
			tx_inclock => s_tx_85x7,
			tx_out(0) => s_C1_XCLK_P,
			tx_out(1) => s_C1_X0_P,
			tx_out(2) => s_C1_X1_P,
			tx_out(3) => s_C1_X2_P,
			tx_out(4) => s_C1_X3_P
		);

	tx_p2 : tx_5lane
		PORT MAP
		(
			tx_enable => s_tx_enable,
			tx_in(6 downto 0) => s_CAMLINK_STRB_parallel,
			tx_in(13 downto 7) => S_CAMLINK_Z0_parallel,
			tx_in(20 downto 14) => S_CAMLINK_Z1_parallel,
			tx_in(27 downto 21) => S_CAMLINK_Z2_parallel,
			tx_in(34 downto 28) => S_CAMLINK_Z3_parallel,
			tx_inclock => s_tx_85x7,
			tx_out(0) => open, --s_C2_ZCLK_P,
			tx_out(1) => s_C2_Z0_P,
			tx_out(2) => s_C2_Z1_P,
			tx_out(3) => s_C2_Z2_P,
			tx_out(4) => s_C2_Z3_P
		);

	-- Separate PLL for Chip Z clock, since that pin is on the opposite side of the FPGA.
	pll85_B : pll_x7_phase_adjust
		port map (
			refclk   => s_hps_0_h2f_user1_clock_clk,
			rst      => s_pll_rst,
			outclk_0 => s_tx_85x7_b,
			outclk_1 => s_tx_enable_b,
			outclk_2 => s_85mhz_b,
			locked   => open
	);

	tx_p2_5 : tx_5lane
		PORT MAP
		(
			tx_enable => s_tx_enable_b,
			tx_in(6 downto 0) => s_CAMLINK_STRB_parallel_shifted,
			tx_in(13 downto 7) => "0000000",
			tx_in(20 downto 14) => "0000000",
			tx_in(27 downto 21) => "0000000",
			tx_in(34 downto 28) => "0000000",
			tx_inclock => s_tx_85x7_b,
			tx_out(0) => s_C2_ZCLK_P,
			tx_out(1) => open,
			tx_out(2) => open,
			tx_out(3) => open,
			tx_out(4) => open 
		);

 	tx_p3 : tx_5lane
		PORT MAP
		(
			tx_enable => s_tx_enable,
			tx_in(6 downto 0) => s_CAMLINK_STRB_parallel,
			tx_in(13 downto 7) => s_CAMLINK_Y0_parallel,
			tx_in(20 downto 14) => s_CAMLINK_Y1_parallel,
			tx_in(27 downto 21) => s_CAMLINK_Y2_parallel,
			tx_in(34 downto 28) => s_CAMLINK_Y3_parallel,
			tx_inclock => s_tx_85x7,
			tx_out(0) => s_C2_YCLK_P, 
			tx_out(1) => s_C2_Y0_P, 
			tx_out(2) => s_C2_Y1_P, 
			tx_out(3) => s_C2_Y2_P, 
			tx_out(4) => s_C2_Y3_P
		);

	--HSMC1_SMSDA -- NC
	--HSMC1_SMSCL -- NC
	 
	--HSMC1_CLKOUT0 -- NC
	--HSMC1_CLKOUT1 -- NC 
	HSMC1_CLKOUT2 <= s_C2_ZCLK_P;
	--HSMC1_CLKIN0 -- NC
	--HSMC1_CLKIN1 -- NC
	--HSMC1_CLKIN2 -- NC
	
	--HSMC1_PRSNTn -- NC
	
	--HSMC1_D0 -- NC
	--HSMC1_D1 -- NC
	--HSMC1_D2 -- NC
	--HSMC1_D3 -- NC
	
	HSMC1_TX0 <= s_C1_X0_P;
	HSMC1_TX1 <= s_C1_X1_P;
	HSMC1_TX2 <= s_C1_X2_P;
	HSMC1_TX3 <= s_C1_XCLK_P;
	HSMC1_TX4 <= s_C1_X3_P;
--	HSMC1_TX5 <= -- SerTFG
	--HSMC1_TX6 -- NC
	--HSMC1_TX7 -- NC 
	HSMC1_TX8 <= s_C2_Y0_P;
	HSMC1_TX9 <= s_C2_Y1_P;
	HSMC1_TX10 <= s_C2_Y2_P;
	HSMC1_TX11 <= s_C2_YCLK_P;
	HSMC1_TX12 <= s_C2_Y3_P;
	HSMC1_TX13 <= s_C2_Z0_P;
	HSMC1_TX14 <= s_C2_Z1_P;
	HSMC1_TX15 <= s_C2_Z2_P;
	HSMC1_TX16 <= s_C2_Z3_P;

--	<= HSMC1_RX0; -- SerTC
	--HSMC1_RX1 -- NC
--	<= HSMC1_RX2; -- CC1 
--	<= HSMC1_RX3; -- CC2 
--	<= HSMC1_RX4; -- CC3
--	<= HSMC1_RX5; -- CC4
	--HSMC1_RX6 -- NC
	--HSMC1_RX7 -- NC

	--! Clocking data into register that we tell compiler to keep will make sure it is not trimmed. 
	--! This will give us the 100 ohm termination we desire.
	process (s_85mhz)
	begin
		if rising_edge(s_85mhz) then
			s_HSMC1_RX8 <= HSMC1_RX8; --term and 100 ohm
		end if;
	end process;

	--HSMC1_RX9 -- NC
	--HSMC1_RX10 -- NC
	--HSMC1_RX11 -- NC
	--HSMC1_RX12 -- NC
	--HSMC1_RX13 -- NC
	--HSMC1_RX14 -- NC
	--HSMC1_RX15 -- NC
	--HSMC1_RX16 -- NC

end architecture rtl; --of mityarm_5csx_dev_board_top

